org.apache.lucene.codecs.lucene53

## Class Lucene53NormsFormat

- java.lang.Object
- - org.apache.lucene.codecs.NormsFormat
  - - org.apache.lucene.codecs.lucene53.Lucene53NormsFormat

-     public class Lucene53NormsFormat
      extends NormsFormat

  Lucene 5.3 Score normalization format.

  Encodes normalization values by encoding each value with the minimum number of bytes needed to represent the range (which can be zero).

  Files:

  1. `.nvd`: Norms data
  2. `.nvm`: Norms metadata

  1. The Norms metadata or .nvm file.

     For each norms field, this stores metadata, such as the offset into the Norms data (.nvd)

     Norms metadata (.dvm) --> Header,<Entry>NumFields,Footer

     - Header --> `IndexHeader`
     - Entry --> FieldNumber,BytesPerValue, Address
     - FieldNumber --> `vInt`
     - BytesPerValue --> `byte`
     - Offset --> `Int64`
     - Footer --> `CodecFooter`

     FieldNumber of -1 indicates the end of metadata.

     Offset is the pointer to the start of the data in the norms data (.nvd), or the singleton value when BytesPerValue = 0

  2. The Norms data or .nvd file.

     For each Norms field, this stores the actual per-document data (the heavy-lifting)

     Norms data (.nvd) --> Header,< Data >NumFields,Footer

     - Header --> `IndexHeader`
     - Data --> `byte`MaxDoc * BytesPerValue
     - Footer --> `CodecFooter`
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Lucene53NormsFormat()` Sole Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `NormsConsumer` | `normsConsumer(SegmentWriteState state)` Returns a `NormsConsumer` to write norms to the index.
    `NormsProducer` | `normsProducer(SegmentReadState state)` Returns a `NormsProducer` to read norms from the index.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Lucene53NormsFormat

          public Lucene53NormsFormat()

      Sole Constructor

  - ### Method Detail

    - #### normsConsumer

          public NormsConsumer normsConsumer(SegmentWriteState state)
                                      throws IOException

      Description copied from class: `NormsFormat`
      Returns a `NormsConsumer` to write norms to the index.
      Specified by:
        `normsConsumer` in class `NormsFormat`
      Throws:
        `IOException`

    - #### normsProducer

          public NormsProducer normsProducer(SegmentReadState state)
                                      throws IOException

      Description copied from class: `NormsFormat`
      Returns a `NormsProducer` to read norms from the index.

      NOTE: by the time this call returns, it must hold open any files it will need to use; else, those files may be deleted. Additionally, required files may be deleted during the execution of this call before there is a chance to open them. Under these circumstances an IOException should be thrown by the implementation. IOExceptions are expected and will automatically cause a retry of the segment opening logic with the newly revised segments.

      Specified by:
        `normsProducer` in class `NormsFormat`
      Throws:
        `IOException`

Copyright © 2000-2019 Apache Software Foundation. All Rights Reserved.